"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.vueAdapater = exports.setActivePinia = void 0;
var pinia_1 = require("pinia");
var evm_1 = require("@gotbit/evm");
var tools_1 = require("../tools");
var global_1 = require("../tools/global");
exports.setActivePinia = pinia_1.setActivePinia;
var stores = {};
var createProxyStore = function (useStore) {
    return new Proxy({}, {
        get: function (_, key) {
            var store = useStore();
            return store[key];
        },
        set: function (_, key, value) {
            var store = useStore();
            store[key] = value;
            return true;
        },
    });
};
var createProxyPermStore = function (name) {
    return new Proxy({}, {
        get: function (_, key) {
            var json = localStorage.getItem(name);
            if (!json)
                return undefined;
            var object = JSON.parse(json);
            return object[key];
        },
        set: function (_, key, value) {
            var json = localStorage.getItem(name);
            var object = {};
            if (json)
                object = JSON.parse(json);
            object[key] = value;
            localStorage.setItem(name, JSON.stringify(object));
            return true;
        },
    });
};
exports.vueAdapater = {
    state: {
        createState: function (name, state) {
            return function (ctx) {
                var _a;
                var useStore = (_a = stores[name]) !== null && _a !== void 0 ? _a : (0, pinia_1.defineStore)(name, {
                    state: function () { return state(ctx); },
                });
                return createProxyStore(useStore);
            };
        },
        createPermState: function (name, state) {
            return function () { return createProxyPermStore(name); };
        },
    },
    init: function (ctx) { return __awaiter(void 0, void 0, void 0, function () {
        var wallet, contracts;
        return __generator(this, function (_a) {
            if (!ctx.DEBUG) {
                (0, global_1.disableDefaultConsole)();
            }
            wallet = (0, evm_1.useModuleSafe)(ctx, evm_1.Wallet);
            contracts = (0, evm_1.useModuleSafe)(ctx, evm_1.Contracts);
            window.debugOn = function () {
                (0, evm_1.enableLogger)();
                (0, evm_1.setLogLevel)('debug', false);
                contracts === null || contracts === void 0 ? void 0 : contracts.printContracts();
                (0, global_1.enableDefaultConsole)();
            };
            window.printLogs = evm_1.printLogs;
            window.pretend = function (address, chainId) {
                return wallet === null || wallet === void 0 ? void 0 : wallet.useWallet().pretend(address, chainId);
            };
            return [2 /*return*/, true];
        });
    }); },
    tools: function (ctx) { return ({
        useWalletHelper: (0, tools_1.useWalletHelper_ctx)(ctx),
    }); },
};
